// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) API to manage scan recipes, targets, and reports. For more information, see the Vulnerability Scanning documentation (https://docs.cloud.oracle.com/iaas/scanning/home.htm).
//

package vulnerabilityscanning

import (
	"encoding/json"
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// HostScanAgentConfiguration Agent configuration for host scan agent settings. This model is polymorphic, presenting different configuration options based on selected agent vendor.
type HostScanAgentConfiguration interface {
}

type hostscanagentconfiguration struct {
	JsonData []byte
	Vendor   string `json:"vendor"`
}

// UnmarshalJSON unmarshals json
func (m *hostscanagentconfiguration) UnmarshalJSON(data []byte) error {
	m.JsonData = data
	type Unmarshalerhostscanagentconfiguration hostscanagentconfiguration
	s := struct {
		Model Unmarshalerhostscanagentconfiguration
	}{}
	err := json.Unmarshal(data, &s.Model)
	if err != nil {
		return err
	}
	m.Vendor = s.Model.Vendor

	return err
}

// UnmarshalPolymorphicJSON unmarshals polymorphic json
func (m *hostscanagentconfiguration) UnmarshalPolymorphicJSON(data []byte) (interface{}, error) {

	if data == nil || string(data) == "null" {
		return nil, nil
	}

	var err error
	switch m.Vendor {
	case "OCI":
		mm := HostScanAgentConfigurationOci{}
		err = json.Unmarshal(data, &mm)
		return mm, err
	default:
		return *m, nil
	}
}

func (m hostscanagentconfiguration) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m hostscanagentconfiguration) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}

// HostScanAgentConfigurationVendorEnum Enum with underlying type: string
type HostScanAgentConfigurationVendorEnum string

// Set of constants representing the allowable values for HostScanAgentConfigurationVendorEnum
const (
	HostScanAgentConfigurationVendorOci HostScanAgentConfigurationVendorEnum = "OCI"
)

var mappingHostScanAgentConfigurationVendorEnum = map[string]HostScanAgentConfigurationVendorEnum{
	"OCI": HostScanAgentConfigurationVendorOci,
}

var mappingHostScanAgentConfigurationVendorEnumLowerCase = map[string]HostScanAgentConfigurationVendorEnum{
	"oci": HostScanAgentConfigurationVendorOci,
}

// GetHostScanAgentConfigurationVendorEnumValues Enumerates the set of values for HostScanAgentConfigurationVendorEnum
func GetHostScanAgentConfigurationVendorEnumValues() []HostScanAgentConfigurationVendorEnum {
	values := make([]HostScanAgentConfigurationVendorEnum, 0)
	for _, v := range mappingHostScanAgentConfigurationVendorEnum {
		values = append(values, v)
	}
	return values
}

// GetHostScanAgentConfigurationVendorEnumStringValues Enumerates the set of values in String for HostScanAgentConfigurationVendorEnum
func GetHostScanAgentConfigurationVendorEnumStringValues() []string {
	return []string{
		"OCI",
	}
}

// GetMappingHostScanAgentConfigurationVendorEnum performs case Insensitive comparison on enum value and return the desired enum
func GetMappingHostScanAgentConfigurationVendorEnum(val string) (HostScanAgentConfigurationVendorEnum, bool) {
	enum, ok := mappingHostScanAgentConfigurationVendorEnumLowerCase[strings.ToLower(val)]
	return enum, ok
}
